=== modified file 'shelf.py'
--- shelf.py	2006-06-05 14:48:11 +0000
+++ shelf.py	2006-06-13 13:20:44 +0000
@@ -81,7 +81,7 @@
     def __path_from_user(self, patch_id):
         try:
             patch_index = int(patch_id)
-        except TypeError:
+        except (TypeError, ValueError):
             raise CommandError("Invalid patch name '%s'" % patch_id)
 
         path = self.__path(patch_index)

=== modified file 'tests.py'
--- tests.py	2006-06-13 02:10:36 +0000
+++ tests.py	2006-06-13 13:20:44 +0000
@@ -526,3 +526,17 @@
         # Check that worked
         self.assertTrue(os.path.exists('.shelf/shelves/default/01'))
         self.assertFalse(os.path.exists('.shelf/shelves/other/01'))
+
+    def test_shelf_bad_patch_arg(self):
+        self.tree = self.make_branch_and_tree('.')
+
+        # Check the bad arg handling
+        stdout, error = self.run_bzr_captured(['unshelve', '01'], retcode=3)
+        self.assertTrue("Patch '01' doesn't exist on shelf" in error)
+
+        stdout, error = self.run_bzr_captured(['unshelve', 'foo'], retcode=3)
+        self.assertTrue("Invalid patch name 'foo'" in error)
+
+        # Hex and is cracky, so it shouldn't work
+        stdout, error = self.run_bzr_captured(['unshelve', '0x00'], retcode=3)
+        self.assertTrue("Invalid patch name '0x00'" in error)

